GNU bug report logs - #47439
27.2; In daemon mode, if after-init-hook errors out, the server does not start

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Gilles <gilles.usenet@HIDDEN>; Keywords: moreinfo; dated Sun, 28 Mar 2021 01:02:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 47439 <at> debbugs.gnu.org:


Received: (at 47439) by debbugs.gnu.org; 28 Mar 2021 17:05:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 28 13:05:29 2021
Received: from localhost ([127.0.0.1]:46925 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lQYqv-0001pA-2d
	for submit <at> debbugs.gnu.org; Sun, 28 Mar 2021 13:05:29 -0400
Received: from mail-qk1-f172.google.com ([209.85.222.172]:41931)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gilles.peskine@HIDDEN>) id 1lQYqs-0001ox-0V
 for 47439 <at> debbugs.gnu.org; Sun, 28 Mar 2021 13:05:27 -0400
Received: by mail-qk1-f172.google.com with SMTP id v70so10297645qkb.8
 for <47439 <at> debbugs.gnu.org>; Sun, 28 Mar 2021 10:05:26 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=g/TVZtqp6Q1cqZzniT7UpePRpLOtCEnriGwJW5pd86s=;
 b=X4lG5z7My1uhKBSOtxl6wUuuMSUKSG2vmt4rFr1UtLHSh2yQo8FkGo+6PKgxhydL6f
 7pgiFe27NwR78LeZ/sK1RykWIprsCIxEcepS22e8bCEU0S0dWyqXFfG4gx+82Da2vRRJ
 Z07Hc2x7Tt/D+POhePcrmZgauJxxq2+UNCgvzzMQop6YjpsCkmv/rdHwWpx76lyAsbr7
 EXcxBh6mymie3Y09Aa0uU1a1yRjkUBnqy2Lbe/HEsgJaGWcGMhC2g1de0du1lH5AEd7/
 Z3XqtdQjjZW9Pgdzw5IPXXfODbyT0vGlVtrjRFhSfJaYd0i40uTJ2snP8V0jhzIq11xV
 GEWw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=g/TVZtqp6Q1cqZzniT7UpePRpLOtCEnriGwJW5pd86s=;
 b=cbtnr8lbt/g6K8RaURh0X5mrPgHTAaeQvbm/r/e5QS3nPz6KFRkdYK5m9g46tMFzpW
 HkgF0R4P3jv5qjJumQ1NVAzqB3NUfZiJ30R4AXRA++TGo/ILuxBJJgGQQOPJzr+GBQpE
 J+v0jlo0jKicdoEr5MA8z8ScLl00/x4/YmkAOWrb1qha6f2BkoYkTsMDkHSO3dSEPJ3T
 eBcGmt4imjoqjWywJl1w3OyAQm5YfsUMpQc6aGU24/STnR8GKF2svRLJ3z2nPSdICm4O
 mTwbZ5ZuijK0mPUfqA1LY/ct/+57Ho1va35ReDOnUUficlo4GCBDjUQDqOgn6LxNGBLu
 D+rg==
X-Gm-Message-State: AOAM5322nob2sWsQ1xPqXBVhgvsjIqmMlpQJc1FdZN7SeiiroelSoeZi
 CFAvucuZx4z25tbQxdkSvcU9sSuC+1+XDVyjQ2Y=
X-Google-Smtp-Source: ABdhPJypVo2MrOZla2uG35c6i0V4WSkLJv10YunYJPrpa6toOhGpR2P2yBrbdi2zuSeIpsTWmAl7TE94pg9K9ZWTdB8=
X-Received: by 2002:ae9:f80b:: with SMTP id x11mr21787010qkh.220.1616951120499; 
 Sun, 28 Mar 2021 10:05:20 -0700 (PDT)
MIME-Version: 1.0
References: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
 <87czvjs7pq.fsf@HIDDEN> <83zgynml0n.fsf@HIDDEN> <87sg4fqqxn.fsf@HIDDEN>
 <83sg4fmios.fsf@HIDDEN> <87k0prqqck.fsf@HIDDEN>
In-Reply-To: <87k0prqqck.fsf@HIDDEN>
From: Gilles <gilles.usenet@HIDDEN>
Date: Sun, 28 Mar 2021 19:04:44 +0200
Message-ID: <CAHf9+Cv+SU186zxNmm3DS-4i30Q5Asw-44GG7KqOaqXvdUEz0A@HIDDEN>
Subject: Re: bug#47439: 27.2; In daemon mode, if after-init-hook errors out,
 the server does not start
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47439
Cc: Eli Zaretskii <eliz@HIDDEN>, 47439 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Looking at the code in startup.el, I think it would be ok to let
errors go uncaught (it would avoid any complication to debug those
errors), but the daemon should start anyway. How about putting most of
command-line in an unwind-protect? Or moving the daemon start outside
the unwind-protect in normal-top-level?

-- Gilles

On Sun, 28 Mar 2021 at 16:56, Lars Ingebrigtsen <larsi@HIDDEN> wrote:
>
> Eli Zaretskii <eliz@HIDDEN> writes:
>
> > You mean, catching the error if we are starting the daemon? that's one
> > possibility, assuming that the error message will then be visible when
> > the first client connects.
> >
> > In non-daemon mode I think we should keep not catching errors.
>
> Yup, and yup.
>
> --
> (domestic pets only, the antidote for overdose, milk.)
>    bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47439; Package emacs. Full text available.

Message received at 47439 <at> debbugs.gnu.org:


Received: (at 47439) by debbugs.gnu.org; 28 Mar 2021 14:56:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 28 10:56:41 2021
Received: from localhost ([127.0.0.1]:46756 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lQWqG-0004ww-Nm
	for submit <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:56:40 -0400
Received: from quimby.gnus.org ([95.216.78.240]:56576)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lQWqD-0004wi-2N
 for 47439 <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:56:39 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=FoMaJmS2wtI4+zxCTZVAgxBFtgbX+CLpK0OJAXs1EK0=; b=J0iMs0S51KKJoCvXpmrVQnjTvx
 G6TSEnANdX1nx7XYF7o7RG2vXPo1BfAUSufDnEk5fw4esl5jeC7amWhSf193F7/e1Nl4ft7jjHpiw
 nC5YrHDhp1p3Jvco3BbI2UHbeL/hKMVcTlPuy+HWH36/NGZuD7CFmPK7+cBFvRi0BOOM=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lQWq4-0003TS-L9; Sun, 28 Mar 2021 16:56:31 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#47439: 27.2; In daemon mode, if after-init-hook errors out,
 the server does not start
References: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
 <87czvjs7pq.fsf@HIDDEN> <83zgynml0n.fsf@HIDDEN>
 <87sg4fqqxn.fsf@HIDDEN> <83sg4fmios.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEX29PKpoJ5ANjyE
 eXv////bjemzAAAAAWJLR0QEj2jZUQAAAAd0SU1FB+UDHA4QLku4gPIAAAGiSURBVDjLnZQJbsQg
 DEVZLoDhAsG+AMv979ZvA0mmlSq1HmWkzMMxvNjj3D8il9nLZJY55+AVBqZ+eZaeSsqjE1FZoOBK
 ClwGSHZzgK8LVAPtAZEV+LEA+7tGMBC5Zk6OOJ0MzwbyAuWAiQQBwI7rwKOY6YAhF5Jwhj4YW+K4
 QA9cFbBmMA2RDch3qs6ADOQJ7wOSa647kyEqhsYLuAWwvk8qG2RdOrc9FiGaD1gxbWufdnFqct7l
 byAmAwGgQ9Z9QNgFSC40AOfbIzGyAtgNAE5u4PMCvMDjKrIB2A3cUaG/7GrxwZfWGA/ALwCFOQ1w
 Pq7wguQK6km1w6Pk7arAbjRTss6XX9oJS/FZiscBzXnSR03LmEcJbtCct0krdsCPWABaKfO1X4Fo
 ax8QuoHitK8Q+4DJxWogpgDwths4KMiXAqy/7Q4Dql0znhaNLAoiG/joXauBKzBh++llVwHsAljr
 LwC7yGiZh4LMp3dn6QWSWi65BWus/T4mVQUJPdSiNeUBpRLmHEDnVYd9fkjsxSZ8Cv4Nxu928xmN
 NQcP+GN8AWUfXI8JbkajAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTAzLTI4VDE0OjE2OjQ2KzAw
 OjAwaXGUtAAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0wMy0yOFQxNDoxNjo0NiswMDowMBgsLAgA
 AAAASUVORK5CYII=
X-Now-Playing: The Style Council's _The Complete Adventures (2)_: "The Stand
 Up Comic's Instructions"
Date: Sun, 28 Mar 2021 16:56:27 +0200
In-Reply-To: <83sg4fmios.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 28 Mar
 2021 17:55:31 +0300")
Message-ID: <87k0prqqck.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > You mean, catching
 the error if we are starting the daemon? that's one > possibility, assuming
 that the error message will then be visible when > the first client connects.
 > > In non-daemon mode I [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47439
Cc: gilles.usenet@HIDDEN, 47439 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> You mean, catching the error if we are starting the daemon? that's one
> possibility, assuming that the error message will then be visible when
> the first client connects.
>
> In non-daemon mode I think we should keep not catching errors.

Yup, and yup.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47439; Package emacs. Full text available.

Message received at 47439 <at> debbugs.gnu.org:


Received: (at 47439) by debbugs.gnu.org; 28 Mar 2021 14:55:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 28 10:55:38 2021
Received: from localhost ([127.0.0.1]:46748 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lQWpG-0004uz-1O
	for submit <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:55:38 -0400
Received: from eggs.gnu.org ([209.51.188.92]:43530)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lQWpF-0004uo-CL
 for 47439 <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:55:37 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53236)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lQWpA-00069q-1q; Sun, 28 Mar 2021 10:55:32 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3414
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lQWp0-0004Ow-Lt; Sun, 28 Mar 2021 10:55:29 -0400
Date: Sun, 28 Mar 2021 17:55:31 +0300
Message-Id: <83sg4fmios.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87sg4fqqxn.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 28 Mar 2021 16:43:48 +0200)
Subject: Re: bug#47439: 27.2; In daemon mode, if after-init-hook errors out,
 the server does not start
References: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
 <87czvjs7pq.fsf@HIDDEN> <83zgynml0n.fsf@HIDDEN> <87sg4fqqxn.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47439
Cc: gilles.usenet@HIDDEN, 47439 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: gilles.usenet@HIDDEN,  47439 <at> debbugs.gnu.org
> Date: Sun, 28 Mar 2021 16:43:48 +0200
> 
> I don't know why the doc string here specifies that there's no error
> handling of this hook in particular -- that's the default for hooks,
> right?
> 
> It seems that it first appeared in 1992:
> 
> +  "Functions to call after loading the init file (~/.emacs).
> +The call is not protected by a condition-case, so you can set `debug-on-error'
> +in .emacs, and put all the actual code on `after-init-hook'.")
> 
> Which is even more confusing -- it seems like the point here is that
> this is a way to run init code, but get debugging?  We now have a
> separate facility for that, so that bit doesn't seem very important any
> more.

It definitely predates the daemon. and I think it relates to what
"--debug-init" does.

> Anyway -- I think perhaps continuing on here and starting the daemon
> might be the most useful solution here, perhaps?

You mean, catching the error if we are starting the daemon? that's one
possibility, assuming that the error message will then be visible when
the first client connects.

In non-daemon mode I think we should keep not catching errors.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47439; Package emacs. Full text available.

Message received at 47439 <at> debbugs.gnu.org:


Received: (at 47439) by debbugs.gnu.org; 28 Mar 2021 14:44:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 28 10:44:01 2021
Received: from localhost ([127.0.0.1]:46729 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lQWe1-0004d2-57
	for submit <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:44:01 -0400
Received: from quimby.gnus.org ([95.216.78.240]:56508)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lQWdz-0004cp-Iw
 for 47439 <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:44:00 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=TnWqgkfsdA16nahPo01LWiXp68RN1E+fSerR1FFbReE=; b=TTWnDfylHgLJ/u6+5OwV/vSVEw
 B3pbgBPttpy/IpVrcBVcyjYH889TVv7BLCZXYxkeiSD/a9g+K2KOVcORFJmntiqgmjSInFyVN88VY
 9z/ajVW2/SfMejdMZ32LKaIxRixFeK5esO9LfjSl/ikVX+Jddh3nLrqz2c72Qutiuhec=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lQWdq-0003Pw-8u; Sun, 28 Mar 2021 16:43:52 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#47439: 27.2; In daemon mode, if after-init-hook errors out,
 the server does not start
References: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
 <87czvjs7pq.fsf@HIDDEN> <83zgynml0n.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEX29PKpoJ5ANjyE
 eXv////bjemzAAAAAWJLR0QEj2jZUQAAAAd0SU1FB+UDHA4QLku4gPIAAAGiSURBVDjLnZQJbsQg
 DEVZLoDhAsG+AMv979ZvA0mmlSq1HmWkzMMxvNjj3D8il9nLZJY55+AVBqZ+eZaeSsqjE1FZoOBK
 ClwGSHZzgK8LVAPtAZEV+LEA+7tGMBC5Zk6OOJ0MzwbyAuWAiQQBwI7rwKOY6YAhF5Jwhj4YW+K4
 QA9cFbBmMA2RDch3qs6ADOQJ7wOSa647kyEqhsYLuAWwvk8qG2RdOrc9FiGaD1gxbWufdnFqct7l
 byAmAwGgQ9Z9QNgFSC40AOfbIzGyAtgNAE5u4PMCvMDjKrIB2A3cUaG/7GrxwZfWGA/ALwCFOQ1w
 Pq7wguQK6km1w6Pk7arAbjRTss6XX9oJS/FZiscBzXnSR03LmEcJbtCct0krdsCPWABaKfO1X4Fo
 ax8QuoHitK8Q+4DJxWogpgDwths4KMiXAqy/7Q4Dql0znhaNLAoiG/joXauBKzBh++llVwHsAljr
 LwC7yGiZh4LMp3dn6QWSWi65BWus/T4mVQUJPdSiNeUBpRLmHEDnVYd9fkjsxSZ8Cv4Nxu928xmN
 NQcP+GN8AWUfXI8JbkajAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTAzLTI4VDE0OjE2OjQ2KzAw
 OjAwaXGUtAAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0wMy0yOFQxNDoxNjo0NiswMDowMBgsLAgA
 AAAASUVORK5CYII=
X-Now-Playing: The Style Council's _The Complete Adventures (2)_:
 "Homebreakers"
Date: Sun, 28 Mar 2021 16:43:48 +0200
In-Reply-To: <83zgynml0n.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 28 Mar
 2021 17:05:12 +0300")
Message-ID: <87sg4fqqxn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > The problem here is
 that if the daemon signals an error any place > during startup before it
 starts the server, there's no way at all to > communicate with the daemon,
 so you cannot know what happen [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47439
Cc: gilles.usenet@HIDDEN, 47439 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> The problem here is that if the daemon signals an error any place
> during startup before it starts the server, there's no way at all to
> communicate with the daemon, so you cannot know what happened and why.
>
> So I think we should provide one of the following, in case of such
> errors:
>
>  . exit the daemon and leave the description of the problem on some
>    disk file, or display it on the screen
>  . start the server and allow clients to connect and see the error
>    message, with or without the backtrace

Ah, right -- in this error mode, the Emacs starts, but there's no
feedback on the error -- it just hangs, and if you `C-c' it on the
command line, the Emacs is running in the background, but the daemon
hasn't started.

So that's, indeed, a very bad way to handle errors here.

I don't know why the doc string here specifies that there's no error
handling of this hook in particular -- that's the default for hooks,
right?

It seems that it first appeared in 1992:

+  "Functions to call after loading the init file (~/.emacs).
+The call is not protected by a condition-case, so you can set `debug-on-error'
+in .emacs, and put all the actual code on `after-init-hook'.")

Which is even more confusing -- it seems like the point here is that
this is a way to run init code, but get debugging?  We now have a
separate facility for that, so that bit doesn't seem very important any
more.

Anyway -- I think perhaps continuing on here and starting the daemon
might be the most useful solution here, perhaps?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47439; Package emacs. Full text available.

Message received at 47439 <at> debbugs.gnu.org:


Received: (at 47439) by debbugs.gnu.org; 28 Mar 2021 14:05:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 28 10:05:17 2021
Received: from localhost ([127.0.0.1]:46675 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lQW2X-0001W8-AA
	for submit <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:05:17 -0400
Received: from eggs.gnu.org ([209.51.188.92]:36666)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lQW2U-0001Vt-OQ
 for 47439 <at> debbugs.gnu.org; Sun, 28 Mar 2021 10:05:15 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52745)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lQW2N-0000sH-LD; Sun, 28 Mar 2021 10:05:09 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4294
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lQW2M-0001Xo-AE; Sun, 28 Mar 2021 10:05:07 -0400
Date: Sun, 28 Mar 2021 17:05:12 +0300
Message-Id: <83zgynml0n.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87czvjs7pq.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 28 Mar 2021 15:56:01 +0200)
Subject: Re: bug#47439: 27.2;
 In daemon mode, if after-init-hook errors out, the server does not
 start
References: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
 <87czvjs7pq.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47439
Cc: gilles.usenet@HIDDEN, 47439 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Date: Sun, 28 Mar 2021 15:56:01 +0200
> Cc: 47439 <at> debbugs.gnu.org
> 
> There is no `condition-case' around the running of this hook;
> therefore, if `debug-on-error' is non-nil, an error in one of
> these functions will invoke the debugger.
> ---
> 
> So I think this is expected behaviour?  Anybody got an opinion?

The problem here is that if the daemon signals an error any place
during startup before it starts the server, there's no way at all to
communicate with the daemon, so you cannot know what happened and why.

So I think we should provide one of the following, in case of such
errors:

 . exit the daemon and leave the description of the problem on some
   disk file, or display it on the screen
 . start the server and allow clients to connect and see the error
   message, with or without the backtrace




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47439; Package emacs. Full text available.
Added tag(s) moreinfo. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 47439 <at> debbugs.gnu.org:


Received: (at 47439) by debbugs.gnu.org; 28 Mar 2021 13:56:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 28 09:56:21 2021
Received: from localhost ([127.0.0.1]:46656 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lQVtt-0007by-MY
	for submit <at> debbugs.gnu.org; Sun, 28 Mar 2021 09:56:21 -0400
Received: from quimby.gnus.org ([95.216.78.240]:56004)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lQVtr-0007bq-4V
 for 47439 <at> debbugs.gnu.org; Sun, 28 Mar 2021 09:56:20 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=h9RE/iPjc3QCkGWQr2oiDZqerXjv86nUaRBFmrus0iI=; b=WVr0CkIQkWYA1b/STCJfGxNKtK
 jTstUMqgpKBzuz/v3Jm93492NtAYjx5vG++e2CZuVfwjkpKcESkhyBxWoKBVoIL9lp4MIcuVGHmQI
 b+jPaOTAKj/M1uvhieb69egf1CoGynduSD2v2HiQYHz5PHCK1ryvFE+Urz12va57vyuc=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lQVta-0002sJ-V5; Sun, 28 Mar 2021 15:56:12 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Gilles <gilles.usenet@HIDDEN>
Subject: Re: bug#47439: 27.2; In daemon mode, if after-init-hook errors out,
 the server does not start
References: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
X-Now-Playing: The Style Council's _The Complete Adventures (2)_: "Headstart
 for Happiness (Version 2)"
Date: Sun, 28 Mar 2021 15:56:01 +0200
In-Reply-To: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
 (Gilles's message of "Sun, 28 Mar 2021 03:00:40 +0200")
Message-ID: <87czvjs7pq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Gilles <gilles.usenet@HIDDEN> writes: > 1. Make an init
 file with the following line: (add-hook 'after-init-hook 'barf) > 2. Start
 Emacs in daemon mode: HOME=$PWD emacs --no-site-file --daemon=foo > > Expected
 behavior: Emacs starts norma [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47439
Cc: 47439 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Gilles <gilles.usenet@HIDDEN> writes:

> 1. Make an init file with the following line: (add-hook 'after-init-hook 'barf)
> 2. Start Emacs in daemon mode: HOME=$PWD emacs --no-site-file --daemon=foo
>
> Expected behavior: Emacs starts normally (including starting the
> server), with the error logged in *Messages* (and optionally on Emacs's
> stderr), as happens for errors in the init file or in
> emacs-startup-hook.
>
> Actual behavior: the server does not start, so there is no way to
> open a frame other than the initial daemon frame.

The doc string for this variable is pretty explicit about errors:

---
There is no `condition-case' around the running of this hook;
therefore, if `debug-on-error' is non-nil, an error in one of
these functions will invoke the debugger.
---

So I think this is expected behaviour?  Anybody got an opinion?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47439; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 28 Mar 2021 01:01:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 27 21:01:21 2021
Received: from localhost ([127.0.0.1]:45171 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lQJnt-0006zF-Gj
	for submit <at> debbugs.gnu.org; Sat, 27 Mar 2021 21:01:21 -0400
Received: from lists.gnu.org ([209.51.188.17]:41654)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gilles.peskine@HIDDEN>) id 1lQJnr-0006z8-SV
 for submit <at> debbugs.gnu.org; Sat, 27 Mar 2021 21:01:20 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:41506)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <gilles.peskine@HIDDEN>)
 id 1lQJnr-00080C-GW
 for bug-gnu-emacs@HIDDEN; Sat, 27 Mar 2021 21:01:19 -0400
Received: from mail-qv1-xf30.google.com ([2607:f8b0:4864:20::f30]:41848)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <gilles.peskine@HIDDEN>)
 id 1lQJnp-0006z6-NF
 for bug-gnu-emacs@HIDDEN; Sat, 27 Mar 2021 21:01:19 -0400
Received: by mail-qv1-xf30.google.com with SMTP id q12so4828378qvc.8
 for <bug-gnu-emacs@HIDDEN>; Sat, 27 Mar 2021 18:01:16 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=RTEaiX/j3t2px45h4bEn8QAmoYkUT3j6riyWHeIfmBg=;
 b=FcwToQmpgVaBE3kZ47AOnttbw5dljT+PIaNOcuUbeT4PvFZki7WG0TG7ER3AG/Z/aO
 HRh/PK/PGDTp6yRI096XE4sMHuBZShIUGmuT3+GAUbmksebmTPGT1BjuT+5q8dj3tFb8
 o2tOToFfkabR/iabqprxptn2pzz9U46iTqGiiqjhxdCmHTVwSkU6gc5T6G0NdSWiimcG
 1q9x9inS+4hKqYxJB2JPEwUSjPeWRoyt1pNO3z4jJQ3sYx4GbyGcIxnIEe0GaT2tIzPB
 6SiaUz5fqkAZendfJCYHNZTsoQCWlU5wSte+ff+/xAgmHsXcYzJSCWSU4hpjP2V0mYx9
 2mMQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=RTEaiX/j3t2px45h4bEn8QAmoYkUT3j6riyWHeIfmBg=;
 b=J8coEE/mcMAI7YBzV3WR8Z/Y4i0mlRAmL9qZttB7T5iPc2r/mugpFW8U8IznwxOQZU
 /M5avmTUUpDXddWvnu0sjcHcK5FOLagzdn8MPKu0C/K8cm8hhLiaGJrDxicw045YcdMH
 yPHyD6OEcNS1XrhPyWpwznq1H0Cbe8GxKXihTuOJV/ZmRLw1fl6INUQWM+KbqSlDcsDY
 TKFhSf8/pyaHsbFupd5OJkI/4Y49NT8nvO1UwDyjjteMGdkvc8deGeDh1crBFmNoxLxa
 OwQtHG/Ywk1dm9AwkigaIQxCsWwqy1lNyRa2qDIRufT0ftnAeaU7/uJj1aNPum06+Akn
 7Njg==
X-Gm-Message-State: AOAM533fLxtr5pvSf+zjVJfxajBa+KNm5te+xcXvHRbGaCx4ibd6MtYQ
 BkYYwHDJFSlFOQGdfqy/i0b8QKQTXoKR6Av9OGiVn3vnbc0VTA==
X-Google-Smtp-Source: ABdhPJw7AVte1iBDMcxspPdeNx0umnl5vS74xlGJxzO77q2i+FzodvCE6Kv3SfQuSso+NSWZ8ZSWzBGoOICmgD/lvwA=
X-Received: by 2002:a05:6214:20ad:: with SMTP id
 13mr18977439qvd.35.1616893276275; 
 Sat, 27 Mar 2021 18:01:16 -0700 (PDT)
MIME-Version: 1.0
From: Gilles <gilles.usenet@HIDDEN>
Date: Sun, 28 Mar 2021 03:00:40 +0200
Message-ID: <CAHf9+CvzPeg24rXeeN2c64CQGbhjyEPc0Kb0rF3bCtScSUGNhQ@HIDDEN>
Subject: 27.2; In daemon mode, if after-init-hook errors out, the server does
 not start
To: bug-gnu-emacs@HIDDEN
Content-Type: text/plain; charset="UTF-8"
Received-SPF: pass client-ip=2607:f8b0:4864:20::f30;
 envelope-from=gilles.peskine@HIDDEN; helo=mail-qv1-xf30.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

1. Make an init file with the following line: (add-hook 'after-init-hook 'barf)
2. Start Emacs in daemon mode: HOME=$PWD emacs --no-site-file --daemon=foo

Expected behavior: Emacs starts normally (including starting the
server), with the error logged in *Messages* (and optionally on Emacs's
stderr), as happens for errors in the init file or in
emacs-startup-hook.

Actual behavior: the server does not start, so there is no way to
open a frame other than the initial daemon frame.

I did most of the investigation with a debug build of Emacs 27.2 on
Linux, but I observed the same symptoms with Emacs 27.1 on macOS,
with the official Ubuntu 20.04 build of Emacs 26.3, and with the
official Ubuntu 16.04 build of Emacs 24.5.1.

In GNU Emacs 27.2 (build 2, x86_64-pc-linux-gnu, X toolkit, Xaw scroll bars)
 of 2021-03-27 built on darkstar
Repository revision: deef5efafb70f4b171265b896505b92b6eef24e6
Repository branch: HEAD
Windowing system distributor 'The X.Org Foundation', version 11.0.12009000
System Description: Ubuntu 20.04.2 LTS

Configured using:
 'configure --with-x-toolkit=lucid --enable-checking=yes,glyphs
 --enable-check-lisp-object-type
 --prefix=/home/gilles/Packages/emacs-27.2-dbg 'CFLAGS=-g3 -O0'
 LDFLAGS=-g3'

Configured features:
XPM JPEG TIFF GIF PNG SOUND GSETTINGS GLIB NOTIFY INOTIFY LIBSELINUX
GNUTLS LIBXML2 FREETYPE HARFBUZZ XFT ZLIB TOOLKIT_SCROLL_BARS LUCID X11
XDBE XIM MODULES THREADS PDUMPER GMP

Important settings:
  value of $LC_CTYPE: en_US.UTF-8
  locale-coding-system: utf-8-unix

Backtrace of the daemon process:
[New LWP 1377142]
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib/x86_64-linux-gnu/libthread_db.so.1".
0x00007f214d60f246 in __pselect (nfds=8, readfds=0x7ffeb73ecd70,
writefds=0x7ffeb73ecdf0, exceptfds=0x0, timeout=<optimized out>,
sigmask=<optimized out>) at ../sysdeps/unix/sysv/linux/pselect.c:48
48      ../sysdeps/unix/sysv/linux/pselect.c: No such file or directory.
SIGINT is used by the debugger.
Are you sure you want to change it? (y or n) [answered Y; input not
from terminal]
DISPLAY = :0
TERM = xterm
Breakpoint 1 at 0x562be7588dbd: file emacs.c, line 379.
Breakpoint 2 at 0x562be753a6f6: file xterm.c, line 10145.
#0  0x00007f214d60f246 in __pselect (nfds=8, readfds=0x7ffeb73ecd70,
writefds=0x7ffeb73ecdf0, exceptfds=0x0, timeout=<optimized out>,
sigmask=<optimized out>) at ../sysdeps/unix/sysv/linux/pselect.c:48
#1  0x0000562be7845fbe in really_call_select (arg=0x7ffeb73ecc60) at
thread.c:586
#2  0x0000562be76ac0ff in flush_stack_call_func (func=0x562be7845ef3
<really_call_select>, arg=0x7ffeb73ecc60) at alloc.c:4951
#3  0x0000562be78460ba in thread_select (func=0x7f214d60f180
<__pselect>, max_fds=8, rfds=0x7ffeb73ecd70, wfds=0x7ffeb73ecdf0,
efds=0x0, timeout=0x7ffeb73ed3a0, sigmask=0x0) at thread.c:616
#4  0x0000562be78ae770 in xg_select (fds_lim=8, rfds=0x7ffeb73ed410,
wfds=0x7ffeb73ed490, efds=0x0, timeout=0x7ffeb73ed3a0, sigmask=0x0) at
xgselect.c:117
#5  0x0000562be77b7c7c in wait_reading_process_output (time_limit=0,
nsecs=0, read_kbd=-1, do_display=true, wait_for_cell=XIL(0),
wait_proc=0x0, just_wait_proc=0) at process.c:5572
#6  0x0000562be759f260 in kbd_buffer_get_event (kbp=0x7ffeb73ed770,
used_mouse_menu=0x7ffeb73edd75, end_time=0x0) at keyboard.c:3866
#7  0x0000562be759989d in read_event_from_main_queue (end_time=0x0,
local_getcjmp=0x7ffeb73edb80, used_mouse_menu=0x7ffeb73edd75) at
keyboard.c:2156
#8  0x0000562be7599cb3 in read_decoded_event_from_main_queue
(end_time=0x0, local_getcjmp=0x7ffeb73edb80, prev_event=XIL(0),
used_mouse_menu=0x7ffeb73edd75) at keyboard.c:2220
#9  0x0000562be759c030 in read_char (commandflag=1,
map=XIL(0x562be8a95aa3), prev_event=XIL(0),
used_mouse_menu=0x7ffeb73edd75, end_time=0x0) at keyboard.c:2830
#10 0x0000562be75ae73b in read_key_sequence (keybuf=0x7ffeb73edf60,
prompt=XIL(0), dont_downcase_last=false, can_return_switch_frame=true,
fix_current_buffer=true, prevent_redisplay=false) at keyboard.c:9554
#11 0x0000562be7596f70 in command_loop_1 () at keyboard.c:1350
#12 0x0000562be770e339 in internal_condition_case (bfun=0x562be7596ad2
<command_loop_1>, handlers=XIL(0x90), hfun=0x562be7596082 <cmd_error>)
at eval.c:1356
#13 0x0000562be7596693 in command_loop_2 (ignore=XIL(0)) at keyboard.c:1091
#14 0x0000562be770d71c in internal_catch (tag=XIL(0xcc60),
func=0x562be7596662 <command_loop_2>, arg=XIL(0)) at eval.c:1117
#15 0x0000562be759662d in command_loop () at keyboard.c:1070
#16 0x0000562be7595b49 in recursive_edit_1 () at keyboard.c:714
#17 0x0000562be7595d49 in Frecursive_edit () at keyboard.c:786
#18 0x0000562be758b75d in main (argc=3, argv=0x7ffeb73ee3e8) at emacs.c:2067
[Inferior 1 (process 1377141) detached]




Acknowledgement sent to Gilles <gilles.usenet@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#47439; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 28 Mar 2021 17:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.